;(function() {

  function require(id) {
    switch (id) {
      case 'react/lib/invariant':
        return invariant;
      case 'react/lib/mergeInto':
        return mergeInto;
      case 'react/lib/merge':
        return merge;
      case 'react/lib/ExecutionEnvironment':
        return ExecutionEnvironment;
      case 'react/lib/cloneWithProps':
        return React.addons.cloneWithProps;
      case 'react/lib/emptyFunction':
        return emptyFunction;
      default:
        throw new Error("unknown module '" + id + "'");
    }
  }

  function invariant(check, msg) {
    if (!check) {
      throw new Error(msg);
    }
  }

  function mergeInto(dst, src) {
    for (var k in src) {
      if (src.hasOwnProperty(k)) {
        dst[k] = src[k];
      }
    }
  }

  function merge(a, b) {
    var c = {};
    mergeInto(c, a);
    mergeInto(c, b);
    return c;
  }

  function emptyFunction() {
  }

  ExecutionEnvironment = {
    canUseDOM: true
  };

  ReactUpdates = {
    batchedUpdates: function(cb) { cb(); }
  };

  window.require = require;
})();
